import Head from 'next/head'
import React from 'react'
import * as dc from '../shared/share-recover.js'
import Image from 'next/image'
import {
  Share,
  ShareSuccess,
  PageHeading,
  Recover,
  Button,
  icons,
  text,
} from 'dark-crystal-web3-ui-components'
import h from 'react-hyperscript'

// In the case of the online version, this would be the actual eth Address
// from the web3 interface
const ethAddress = '0xblahblah'

export default class Home extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      currentTab: 'backup',
    }
  }

  componentDidMount() {}

  render() {
    return h('div', [
      h(Head, [
        h('title', 'Dark Crystal Web3'),
        h('link', { rel: 'icon', href: '/favicon.ico' }),
      ]),
      h('main', { className: 'pb-4' }, [
        h(
          'div',
          {
            className:
              'mx-auto max-w-screen-xxxl bg-crystal-background bg-center bg-cover text-white pb-4 mb-4',
          },
          [
            h('div.px-4.pb-4', [
              h('div.flex.justify-between', [
                h('div', [
                  h(
                    'h1',
                    {
                      className:
                        'font-silkscreen uppercase text-3xl font-semibold',
                    },
                    text.appName
                  ),
                  h('p.text-sm', text.appSubtext),
                ]),
                h('div', [
                  h('h1', { className: 'font-silkscreen uppercase text-xl' }, [
                    h('span.mr-4', text.secretOwner),
                    // TODO hamburger menu here
                    ['backup', 'recover'].map((tab) => {
                      return h(Button, {
                        key: tab,
                        onClick: () => {
                          this.setState({ currentTab: tab })
                        },
                        active: this.state.currentTab === tab,
                        text: tab,
                      })
                    }),
                  ]),
                  // ]),
                ]),
              ]),
            ]),
            h(
              'div',
              { className: 'container mx-auto p-5 sm:px-10 lg:pl-36 my-auto' },
              [
                h(
                  PageHeading,
                  Object.assign(
                    {
                      icon: icons('cofre-cerrado'),
                    },
                    text.pageHeadings[this.state.currentTab]
                  )
                ),
              ]
            ),
          ]
        ),
        h('div', { className: 'container mx-auto max-w-screen-xxxl h-80' }, [
          h('div', { className: 'p-5 sm:px-10 flex lg:pl-36' }, [
            h(Share, {
              ethAddress,
              visible: this.state.currentTab === 'backup',
              ShareSuccess,
              dc,
            }),
            h(Recover, {
              ethAddress,
              visible: this.state.currentTab === 'recover',
              dc,
            }),
          ]),
        ]),
      ]),
    ])
  }
}
